/******************************************************************************
Copyright (C) 2022  Beiing Eswin Co. Ltd
******************************************************************************
File Name     : sample.c
Version       : Initial Draft
Author        : Eswin
Created       : 2023/11/12
Last Modified :
Description   :	sample for cipher
Function List :
History       :
******************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <essdk/es_type.h>

extern ES_S32 sample_aes_sm4(ES_VOID);
extern ES_S32 sample_hash(ES_VOID);
extern ES_S32 sample_trng(ES_VOID);
extern ES_S32 sample_image_dec(ES_VOID);
extern ES_S32 sample_rsa(ES_VOID);
extern ES_S32 sample_nsign_verify(ES_VOID);
extern int sample_ecdh(ES_VOID);
extern int sample_rsa_sign(ES_VOID);

int main(int argc, char *argv[])
{
    ES_S32 s32Ret = ES_FAILURE;
    ES_U32 funcNumber = 0;

    #ifdef ES_CIPHER_QEMU_DEBUG
    printf("%s, CIPHER ES_CIPHER_QEMU_DEBUG is defined!\n", __func__);
    #endif
    if(argc < 2)
    {
        printf("\n##########----Run a cipher sample:for example, ./sample_cipher 1----###############\n");
        printf("    Please selset a cipher sample to run as fllow:\n"
                   "    [1] aes_sm4\n"
                   "    [2] hash\n"
                   "    [3] trng\n"
                   "    [4] image_dec\n"
                   "    [5] rsa\n"
                   "    [6] nsign_verify\n"
                   "    [7] ecdh\n"
                   "    [8] rsa sign and verify\n");

        return ES_FAILURE;
    }

    funcNumber = strtol(argv[1], NULL, 0);
    switch (funcNumber)
    {
        case 1:
            printf("\n~~~~~~~~~~~~~~~~~~~~~ run sample_aes_sm4 ~~~~~~~~~~~~~~~~~~~\n");
            s32Ret = sample_aes_sm4();
            break;
        case 2:
            printf("\n~~~~~~~~~~~~~~~~~~~~~ run sample_hash ~~~~~~~~~~~~~~~~~~~\n");
            s32Ret = sample_hash();
            break;
        case 3:
            printf("\n~~~~~~~~~~~~~~~~~~~~~ run sample_trng ~~~~~~~~~~~~~~~~~~~\n");
            s32Ret = sample_trng();
            break;
        case 4:
            printf("\n~~~~~~~~~~~~~~~~~~~~~ run sample_hash ~~~~~~~~~~~~~~~~~~~\n");
            s32Ret = sample_image_dec();
            break;
        case 5:
            printf("\n~~~~~~~~~~~~~~~~~~~~~ run sample_rsa ~~~~~~~~~~~~~~~~~~~\n");
            s32Ret = sample_rsa();
            break;
        case 6:
            printf("\n~~~~~~~~~~~~~~~~~~~~~ run sample_nsign_verify ~~~~~~~~~~~~~~~~~~~\n");
            s32Ret = sample_nsign_verify();
            break;
        case 7:
            printf("\n~~~~~~~~~~~~~~~~~~~~~ run sample_ecdh ~~~~~~~~~~~~~~~~~~~\n");
            s32Ret = sample_ecdh();
            break;
        case 8:
            printf("\n~~~~~~~~~~~~~~~~~~~~~ run sample_rsa_sign ~~~~~~~~~~~~~~~~~~~\n");
            s32Ret = sample_rsa_sign();
            break;
        default:
            printf("Function Number %d do not exist!\n", funcNumber);
            s32Ret = ES_FAILURE;
            break;
    }

    if(ES_SUCCESS == s32Ret)
    {
        printf("\n################# FUNCTION %d RUN SUCCESS #################\n", funcNumber);
    }
    else
    {
        printf("\n################# FUNCTION %d RUN FAILURE #################\n", funcNumber);
    }

    return s32Ret;
}

