/******************************************************************************
Copyright (C) 2022  Beiing Eswin Co. Ltd
******************************************************************************
File Name     : sample_trng.c
Version       : Initial Draft
Author        : Eswin
Created       : 2023
Last Modified :
Description   : sample for true random generation
Function List :
History       :
******************************************************************************/
#include "sample_cipher_common.h"

int sample_trng(ES_VOID)
{
	ES_S32 i, ret = ES_SUCCESS;
	ES_U32 len[3] = {128, 256, 512};
	ES_U8 *pu8RandomNumber = NULL;

	printf("Hello %s\n", __func__);

	ret = ES_CIPHER_Init();
	if (ret != ES_SUCCESS) {
		ES_ERR_CIPHER("%s, ES_CIPHER_Init failed!\n", __func__);
		return ret;
	}


	for (i = 0; i < 3; i++)
	{
		printf("%s generates %d bytes of random begin---\n", __func__, len[i]);
		pu8RandomNumber = malloc(len[i]);
		if (NULL == pu8RandomNumber) {
			ES_ERR_CIPHER("%s, failed to malloc buffer for trng data!\n", __func__);
			ret = ES_FAILURE;
			goto CIPHER_EXIT;
		}

		memset(pu8RandomNumber, 0, len[i]);

		ret = ES_CIPHER_GetRandomNumber(pu8RandomNumber, len[i]);
		if (ret != ES_SUCCESS){
			ES_ERR_CIPHER("%s, failed! errCode:0x%x\n", __func__, ret);
			ret = ES_FAILURE;
			free(pu8RandomNumber);
			goto CIPHER_EXIT;
		}
		free(pu8RandomNumber);
	}

CIPHER_EXIT:
	ES_CIPHER_DeInit();

	return ret;


}